#!/bin/sh

myname=`basename $0`

echo "Content-Type: text/html; charset=iso-8859-1"
echo "Cache-control: no-store" # HTTP/1.1 (or no-cache?)
echo "Pragma: no-cache"        # HTTP/1.0
echo "Expires: `date -Ru`"     # Expires now!
echo
echo "<html><head>"
echo '<LINK REL=STYLESHEET TYPE="text/css" HREF="main.css">'
echo "<title>SETI@home status</title>"
echo "</head><body>"

. /etc/seti.conf

dir="$SETI_DIR"
pidfile=/var/run/seti.pid

if [ -f $pidfile ] ; then
  # prozente
  if  grep prog $dir/state.sah 1>/dev/nul  ; then
    p=`grep prog= $dir/state.sah | sed s/prog=//g`
    p=`echo $p | sed s/0[.]//g`

    # nur 3 stellen behalten
    p=`echo $p | sed s/.....$//g`

    # das nachkomma
    nk=`echo $p | sed s/^..//g`
    p=`echo $p | sed s/.$//g`

    # prog ausgeben
    usage=`echo "$p,$nk"`

    echo '<table border="0" width="95%" cellspacing="0" cellpadding="0" bgcolor="#C0C0C0" align="center"><tr>'
    echo "<td align=left> <b>SETI@home status</b></td>"
    echo '</tr></table>'

    echo '<table border="0" width="95%" align="center" cellspacing="1">'
    echo '<tr bgcolor="#C0C0C0">'
    echo '<th>PID</th><th>current work unit complete</th><th>time</th>'
    echo '<th>eta</th></tr>'
    echo '<tr>'
    echo "<td>`cat $pidfile`</td>"
    echo '<td><table border="0" width="100%" cellspacing="0">'
    echo '<tr>'
    if [ $p -ne 0 ] ; then
      echo "<td width=\"$usage%\" bgcolor=\"green\">$usage%</td>"
    fi
    if [ $p -ne 100 ] ; then
      echo "<td width=\"`expr 100 - $usage`%\" bgcolor=\"red\">&nbsp;</td>"
    fi
    echo '</tr></table></td>'

  else
    echo "no value, please try later"
  fi

  # die cpuzeit
  if  grep cpu $dir/state.sah 1>/dev/nul  ; then
    c=`grep cpu= $dir/state.sah | sed s/cpu=//g`
    c=`echo $c | sed s/[.]......//g`
    h=`expr $c / 3600`
    r=`expr $c % 3600`
    m=`expr $r / 60`
    s=`expr $m '*' 60`
    s=`expr $r - $s`

    # dezimal stellen korrektur
    if [ "$h" -le "9" ] ; then
      h=`echo 0$h`
    fi

    if [ "$m" -le "9" ] ; then
      m=`echo 0$m`
    fi

    if [ "$s" -le "9" ] ; then
      s=`echo 0$s`
    fi

    # und aus den stunden tage machen wenn noetig

    if [ "$h" -gt "24" ] ; then
      d=`expr $h / 24`
      r=`expr $d '*' 24`
      h=`expr $h - $r`
      h=`echo $d days $h`
    fi

    # cpu-zeit ausgeben
    echo "<td align=\"center\">$h:$m:$s</td>"

    # approximierte zeit berechnen
    ca=`expr $c '*' 1000`

    if [ "$p$nk" -ne 0 ] ; then
      ca=`expr $ca / "$p$nk"`
      c=`expr $ca - $c`
      h=`expr $c / 3600`
      r=`expr $c % 3600`
      m=`expr $r / 60`
      s=`expr $m '*' 60`
      s=`expr $r - $s`

      # dezimal stellen korrektur
      if [ "$h" -le "9" ] ; then
        h=`echo 0$h`
      fi

      if [ "$m" -le "9" ] ; then
        m=`echo 0$m`
      fi

      if [ "$s" -le "9" ] ; then
        s=`echo 0$s`
      fi

      # und aus den stunden tage machen wenn noetig

      if [ "$h" -gt "24" ] ; then
        d=`expr $h / 24`
        r=`expr $d '*' 24`
        h=`expr $h - $r`
        h=`echo $d days $h`
      fi

      echo "<td align=\"center\">$h:$m:$s</td>"
    fi
  else
    echo "no value, please try later"
    echo "</td></tr><tr><td>eta</td><td>"
    echo "no value, please try later"
  fi
  echo "</tr></table>"
else
  echo "setiathome is not running"
fi

echo '<p>some links:</p>'
echo '<ul>'
echo '<li><a href="http://setiathome.ssl.berkeley.edu/" target="_top">SETI@home project homepage at Berkley</a></li>'
echo '<li><a href="http://setiathome.ssl.berkeley.edu/stats/team/team_122270.html" target="_top">FlI4L Team for SETI@home</a></li>'
echo '<li><a href="http://www.schoeppi.net/opt-seti/index.html" target="_top">Download page for OPT_SETI</a></li>'
echo '</ul>'

echo "</body></html>"
